---
name: "\U0001F41B Report bug"
about: "Use this template if the genuine builds of Nuvola aren't working as expected \U0001F914."

---

<!-- Thank you for taking the time to report a new issue.

Before reporting a new issue:

1. Use genuine builds of Nuvola available from <https://nuvola.tiliado.eu>.
    If you use a third-party build, contact your distributor to get help.
    We don't have resources to support packages we know nothing about.
2. Use the latest release of Nuvola. Update often, Flatpak updates are safe.
    Run  "flatpak update --system; flatpak update --user" to make sure
    all your Nuvola packages are up-to-date.
-->

### Basic information

- Your Linux distribution and its version: ...
   <!--
   Replace "..." with your answer, e.g. "Ubuntu 18.04". If you don't know,
   you can use commands "lsb_release -d" or "cat /etc/issue /etc/*release"
   to find out that.
   -->

- Your desktop environment: ...
   <!--
   Replace "..." with your desktop environment, e.g.
   GNOME (default in Ubuntu 17.10 and newer, in Fedora),
   Unity (default in Ubuntu 17.04 and older),
   Patheon (default in elementaryOS),
   Cinnamon (default in Linux Mint)
   KDE, XFCE, MATE, ...
   -->

 - Nuvola Runtime version: ...
   <!--
   Replace "..." with the version of Nuvola Runtime.
   You can get it from About dialog, click Menu button, then About.
   -->

 - The web app you use and its version: ...
   <!--
   Replace "..." with the name (e.g. Deezer, Spotify) and version of
   the web app you use.
   You can get it from About dialog, click Menu button, then About.
   -->

### Describe the bug

<!-- Replace "..." with a clear and concise description of what the bug is. -->
...

**Steps to reproduce the behavior**

<!-- Replace this list with your own steps. -->

1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Expected behavior**

<!-- Replace "..." with a clear and concise description of what you expected to happen. -->
...

**Debugging log**

<!--
See https://github.com/tiliado/nuvolaruntime/wiki/Bug-Reporting-Guidelines#debugging-output
for instructions on how to get a debugging log. Then save it as a text file (*.txt) and attach it to the bug report.

- Use the "Attach files by dragging & dropping or selecting them." feature available under the textbox.
- Never trim the logs or you will be asked to provide new complete logs.
- Don't use "pastebin" services as the logs there may disappear anytime.
- Don't attach screenshots of the terminal output. Use text files.
-->
Attach the debug log here: ...

**Screenshots**

<!--
If applicable, add screenshots to help explain your problem.

- Use the "Attach files by dragging & dropping or selecting them." feature available under the textbox.
- Don't use image hosting services as the images may disappear anytime.
-->
Attach screenshots here: ...

**Additional context**

<!-- Add any other context about the problem. -->
...
