Contributing to Nuvola Apps Project
===================================

:+1::tada: It seems you would like to contrubute to the Nuvola Apps project. Great to have you here.
Here are a few ways you can help make Nuvola better! :tada::+1:
_[Nuvola Apps Team](https://tiliado.eu/nuvolaplayer/team/)_

Bug Reporting
-------------

Whenever you encounter a bug in Nuvola Apps Runtime, don't hesitate to report it. First of all, it is necessary to
submit your issue to the right place:

* Contact [Tiliado support](mailto:support@tiliado.eu) to report issues with Tiliado.eu website (tiliado.eu domain),
  your Tiliado account and memberships.

* Use [the Nuvola Apps Users mailing list](https://groups.google.com/d/forum/nuvola-player-users) to ask general
  questions about Nuvola.

* Finally, for reporting issues and bugs of the Nuvola Apps Runtme and supported services, follow
  [the Bug Reporting Guidelines](https://github.com/tiliado/nuvolaruntime/wiki/Bug-Reporting-Guidelines).

Feature Requests
----------------

Feature requests are welcome. First of all, take a look at
[the Nuvola Runtime issue tracker](https://github.com/tiliado/nuvolaruntime/issues). If there is no
feature request similar to your wish, don't hesitate to
[create a new ticket](https://github.com/tiliado/nuvolaruntime/issues/new) for it.
Please provide as much detail and context as possible.

Web App Script
--------------

Web App Scripts (service integration scripts) run in the web interface and communicates with Nuvola Apps Runtime.
If you want to add support for a new service, follow
[Service Integration Development guides](http://tiliado.github.io/nuvolaplayer/development/apps.html).

*Recommended skills:*
[GIT](http://git-scm.com/),
[JavaScript](https://developer.mozilla.org/en/docs/Web/JavaScript),
[DOM](https://developer.mozilla.org/en-US/docs/Web/API/Document_Object_Model),
[HTML](https://developer.mozilla.org/en-US/docs/Web/HTML).


Core Development
----------------

Nuvola Apps Runtime is currently badly documented. We hope to improve it in the future.
If you are interested in core development, get in touch with us on
[Nuvola Devel mailing list](https://groups.google.com/d/forum/nuvola-player-devel).

*Recommended skills:*
[Vala](https://wiki.gnome.org/Projects/Vala),
[GTK+ 3](http://www.gtk.org/),
[GIT](http://git-scm.com/),
[JavaScript](https://developer.mozilla.org/en/docs/Web/JavaScript)
