Title: Web View Snapshot

[TOC]

Nuvola scripts are distributed as Flatpak packages which contain AppStream metadata to describe them and make them look
sexy in software store applications, e.g. GNOME Software. The AppStream metadata are automatically generated by Nuvola
SDK.

An important feature of the metadata is the **screenshot of the application**. Since maintenance the screenshots and
keeping them up-to-date with Nuvola integration features would impose a significant burden on the script maintainers,
they need to provide only a screenshot of the web view, which is then combined with base screenshots showing
integration features to create final screenshots for AppStream metadata.

This page describes guidelines for the **web view snapshots**.

  * First, navigate to a representative page of your script.
  * Enable *Developer tools* in Preferences.
  * Open *Developer* sidebar and try to remove annoying elements (ads, nag banners):
    ![Remove annoying elements](:images/guide/web_view_snapshot_remove_ads.png)
  * Open *Web View* sidebar, set dimensions to **1080×600** and click *Resize web view*. If it is necessary,
    e.g. because of the breakpoints of responsive layout of the page, you can choose narrower dimensions.
  * Then take a snapshot of the web view and save it as `src/webview.png`.
  * Launch [Nuvola ADK](https://github.com/tiliado/nuvolaruntime/wiki/Nuvola-App-Developer-Kit),
    run `./configure; make all` and look at the resulting screenshots in the `screenshots` directory.
